## autopath-xv 1.0.0

=== Makefile ===
CC = gcc
CFLAGS = -Wall -Wextra -O2 -pthread
LDFLAGS = -pthread
TARGET = autopath-xv
PREFIX = /usr/local
BINDIR = $(PREFIX)/bin
MANDIR = $(PREFIX)/share/man/man1

# Check for libnetsnmp
SNMP_EXISTS := $(shell pkg-config --exists netsnmp 2>/dev/null && echo yes)
ifeq ($(SNMP_EXISTS),yes)
    CFLAGS += -DHAVE_SNMP $(shell pkg-config --cflags netsnmp)
    LDFLAGS += $(shell pkg-config --libs netsnmp)
    $(info Building with SNMP support)
else
    $(info Building without SNMP support - install libnetsnmp-dev for SNMP features)
endif

# Source files
SRCS = main.c netutils.c traceroute.c snmp_query.c
OBJS = $(SRCS:.c=.o)


# Main target
all: $(TARGET)

$(TARGET): $(OBJS)
	$(CC) $(CFLAGS) -o $(TARGET) $(OBJS) $(LDFLAGS)

# Compile object files
%.o: %.c
	$(CC) $(CFLAGS) -c $< -o $@

# Install target
install: $(TARGET)
	install -d $(DESTDIR)$(BINDIR)
	install -m 0755 $(TARGET) $(DESTDIR)$(BINDIR)/
	install -d $(DESTDIR)$(MANDIR)
	gzip -c autopath-xv.1 > $(DESTDIR)$(MANDIR)/autopath-xv.1.gz
	@echo ""
	@echo "Installation complete!"
	@echo "To use without sudo, run: sudo setcap cap_net_raw+ep $(DESTDIR)$(BINDIR)/$(TARGET)"

# Uninstall target
uninstall:
	rm -f $(DESTDIR)$(BINDIR)/$(TARGET)
	rm -f $(DESTDIR)$(MANDIR)/autopath-xv.1.gz

# Clean build artifacts
clean:
	rm -f $(OBJS) $(TARGET)

# Clean everything including backup files
distclean: clean
	rm -f *~ *.orig

# Build .deb package
deb: clean
	dpkg-buildpackage -us -uc -b

.PHONY: all install uninstall clean distclean deb

=== debian/changelog ===
autopath-xv (1.0.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1128072)

 -- Reihan Wiratama <wiratamareyhan85@gmail.com>  Wed, 18 Feb 2026 11:30:00 +0000

=== debian/control ===
Source: autopath-xv
Section: net
Priority: optional
Maintainer: Reihan Wiratama <wiratamareyhan85@gmail.com>
Build-Depends: debhelper-compat (= 13), libsnmp-dev, pkgconf
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://github.com/reyhank45/autopath-xv
Vcs-Git: https://github.com/reyhank45/autopath-xv.git
Vcs-Browser: https://github.com/reyhank45/autopath-xv

Package: autopath-xv
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libcap2-bin
Description: Advanced network path discovery and diagnostic tool
 autopath-xv is a high-performance network traceroute utility designed 
 for sub-second path discovery. It bridges the gap between Layer 3 
 routing and Layer 2 link-layer analysis, supporting:
 .
  * Sub-600ms network-latency-bound execution.
  * Intelligent Path Auditing (Shotgun interface discovery).
  * Layer 2 MAC address resolution per hop.
  * Professional path breakdown and routing loop diagnostics.
  * Advanced Smart Mode for router ARP table analysis.
 Layer 3 traceroute with Layer 2 MAC-level path tracing.
 .
 Features:
  - Traditional ICMP-based traceroute functionality
  - Layer 2 MAC address resolution via ARP
  - Smart mode for querying router ARP tables
  - Broadcast ARP support
  - Debug mode for detailed packet analysis
  - Detection of invalid and missing routes
 .
 The tool requires either root privileges or CAP_NET_RAW capability.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_install:
	$(MAKE) DESTDIR=$$(pwd)/debian/autopath-xv PREFIX=/usr install

override_dh_fixperms:
	dh_fixperms
	# Set capabilities for raw socket access
	chmod 0755 debian/autopath-xv/usr/bin/autopath-xv

=== debian/watch ===
version=4
opts=filenamemangle=s/.*\/v?(\d[\d\.]*)\.tar\.gz/autopath-xv-$1.tar.gz/ \
  https://github.com/Reyhank45/autopath-xv/tags \
  (?:.*/)?v?(\d[\d\.]*)\.tar\.gz
